-- add green border to 100% runs

add_printer("/ascensionhistory.php", function()
	text = text:gsub([[(<img src="http://images.kingdomofloathing.com/itemimages/[^"]+.gif" width=30 height=30 alt="[^"]+" title="[^"]+ %(100%%%)[^"]*")(>)]], [[%1 style="border: thin solid green"%2]])
end)

-- adventure mistake warnings

add_always_adventure_warning(function()
	if drunkenness() > maxsafedrunkenness() then
		return "You might not want to adventure while this drunk.", "overdrunk"
	end
end)

add_ascension_adventure_warning(function(zoneid)
	if level() >= 13 then
		if mcd() > 0 then
			return "You might want to turn off the monster-annoyer.", "turn off monster-annoyer"
		else
			return
		end
	end
	local function should_we_maximize_mcd()
		if zoneid == 34 then
			if mcd() == 4 or mcd() == 8 then
				return false
			end
		end
		return true
	end
	if moonsign_area() == "Degrassi Knoll" then
		if not have("detuned radio") then
			return "You might want to buy a detuned radio.", "buy detuned radio"
		elseif mcd() == 0 then
			return "You might want to set your detuned radio.", "set detuned radio"
		elseif mcd() < 10 and should_we_maximize_mcd() then
			return "You might want to turn up your detuned radio.", "turn up detuned radio"
		end
	elseif moonsign_area() == "Little Canadia" then
		if mcd() == 0 then
			return "You might want to set the Mind-Control Device.", "set Mind-Control Device"
		elseif mcd() < 11 and should_we_maximize_mcd() then
			return "You might want to turn up the Mind-Control Device.", "turn up Mind-Control Device"
		end
	elseif moonsign_area() == "Gnomish Gnomad Camp" then
		if have("bitchin' meatcar") or have("pumpkin carriage") or have("Desert Bus pass") then
			if mcd() == 0 then
				return "You might want to set the Annoy-o-Tron.", "set Annoy-o-Tron"
			elseif mcd() < 10 and should_we_maximize_mcd() then
				return "You might want to turn up the Annoy-o-Tron.", "turn up Annoy-o-Tron"
			end
		end
	end
end)

add_ascension_adventure_warning(function()
	if have("astral shirt") and not have_equipped("astral shirt") and level() < 13 then
		return "You might want to wear your astral shirt for stats.", "wear astral shirt"
	end
end)

add_ascension_adventure_warning(function()
	if basemuscle() >= 45 and have("hipposkin poncho") and not have_equipped("hipposkin poncho") and level() < 13 then
		return "You might want to wear your hipposkin poncho for stats.", "wear hipposkin poncho"
	end
end)

add_ascension_adventure_warning(function()
	if basemuscle() >= 40 and have("Grimacite gown") and not have_equipped("Grimacite gown") and level() < 13 then
		return "You might want to wear your Grimacite gown for stats.", "wear Grimacite gown"
	end
end)

add_ascension_adventure_warning(function()
	if basemuscle() >= 40 and (have("Moonthril Cuirass") or have("Mint-in-box Moonthril Cuirass")) and not have_equipped("Moonthril Cuirass") and level() < 13 then
		return "You might want to wear your Moonthril Cuirass for stats.", "wear Moonthril Cuirass"
	end
end)

add_ascension_adventure_warning(function()
	if basemysticality() >= 35 and have_inventory("hockey stick of furious angry rage") and level() < 13 then
		return "You might want to wear your hockey stick of furious angry rage for stats.", "wear hockey stick of furious angry rage"
	end
end)

add_always_adventure_warning(function()
	if familiarid() == 113 and (ascensionstatus() == "Aftercore" or have("quadroculars")) and not have_equipped("quadroculars") then
		return "You might want to wear quadroculars on your he-boulder.", "wear quadroculars"
	end
end)

add_always_adventure_warning(function()
	if familiarid() == 146 and (ascensionstatus() == "Aftercore" or have("quake of arrows")) and not have_equipped("quake of arrows") then
		return "You might want to wear quake of arrows on your obtuse angel.", "wear quake of arrows"
	end
end)

-- add_ascension_adventure_warning(function()
-- 	if get_mainstat() == "Moxie" and basemoxie() >= 60 and have_inventory("spangly sombrero") and level() < 13 then
-- -- TODO: and not in an outfit-required place
-- 		return "You might want to wear your spangly sombrero for stats.", "wear spangly sombrero"
-- 	end
-- end)

-- add_printer("all pages", function()
-- 	text = text:gsub("</head>", [[
-- 	<style>
-- 		a:hover { opacity: 0.75; }
-- 		a[_type]:hover { opacity: 1.0; } /* combat action bar dropdowns */
-- 		input[class=button]:hover { opacity: 0.75; }
-- 	</style>
-- 	<script language=Javascript src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
-- 	<script>
-- 	jQuery(function($) {
-- 		$('a[href*=".php"]').live('click', function() {
-- 			$('img[width=100][height=100]').not($(this).find('img')).css('opacity', 0.5);
-- 		})
-- 	});
-- 	function funkit(t) {
-- 		console.log("hello", t.href)
-- 	}
-- 	</script>
-- 	%0]])
-- end)

-- add_printer("all pages", function()
-- 	text = text:gsub("</head>", [[
-- 	<script language=Javascript src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
-- 	%0]])
-- 	text = text:gsub([[href="adventure.php%?]], [[onmouseover='javascript:funkit(this)' %0]])
-- end)

--~ add_printer("/main.php", function()
--~ 	text = text:gsub("</head>", [[
--~ <script>
--~ 	$(document).ready(function() {
--~ 		$("table").effect("shake", { times: 4 }, 10);
--~ 	}
--~ </script>
--~ %0]])
--~ end)

-- add_printer("/afterlife.php", function()
-- 	if params.place == "reincarnate" and text:contains("You have unlocked the Bad Moon sign for your next run.") then
-- 		text = text:gsub([[switch%(document.ascform.whichpath.value%) {]], [[
-- if (!document.ascform.whichpath.value) { document.ascform.whichpath.value = '0'; }
-- 	%0
-- 		case 'kolproxyBM': pathimage='../itemimages/badmoon'; pathtext="<b>NOTE:</b>  You have unlocked the Bad Moon sign for your next run.  Be warned:  being born under a Bad Moon is very difficult.  It's like Hardcore, but you don't get to use any of your previous permanent skills -- just the ones you acquire on the run.  The spirits of your familiars will also not return with you, and you'll have to find them again if you want to use them during the run.  Being born under a Bad Moon will also cause you to have a lot of &quot;unlucky&quot; stuff happen to you in various places.<p>It's challenging, but it's fun, and it has its rewards, just like other challenging paths.  There is a separate set of leaderboards for Bad Moon, as well."; break;]])
-- 		text = text:gsub([[(<select name=whichpath.-)(</select>)]], [[%1<option value="kolproxyBM">Bad Moon</option>%2]])
-- 		text = text:gsub([[$%('option%[value=10%]'%).remove%(%);]], [[%0
-- 		$('option[value=kolproxyBM]').remove();
-- 		pathoptions();]])
-- 		text = text:gsub([[$%('select%[name="whichsign"%]'%).append%('<option value="10">Bad Moon</option>'%);]], [[$('select[name="whichpath"]').append('<option value="kolproxyBM">Bad Moon</option>');]])
-- 		text = text:gsub([[document.pathpic.src=]], [[
-- if (document.ascform.whichpath.value == "kolproxyBM") {
-- 		hidediv('moonsigns');
-- 		$('option[value=10]').remove();
-- 		$('select[name="whichsign"]').append('<option value=10 >Bad Moon</option>');
-- 		document.ascform.whichsign.value = "10";
-- 		moonpreview();
-- 	} else if (document.ascform.asctype.value != 0) {
-- 		showdiv('moonsigns');
-- 		$('option[value=10]').remove();
-- 		moonpreview();
-- 	}
-- 	%0]])
-- 		text = text:gsub([[if %(sign == 10%) hidediv%('path'%);]], [[]])
-- 		text = text:gsub([[else if %(lifestyle >  1 %) showdiv%('path'%);]], [[]])
-- 	end
-- end)

add_printer("/charpane.php", function()
	ttr = tonumber(text:match("var turnsthisrun = ([0-9]+);"))
	if not ttr then return end
	if text:contains("inf_small.gif") then return end
	if ascensionstatus() ~= "Aftercore" then return end
	local href = "http://kol.obeliks.de" .. raw_make_href("/buffbot/buff", {
		{ key = "style", value = "kol" },
-- 		{ key = "style", value = "kolproxy" },
		{ key = "target", value = playername() },
	})
	text = text:gsub([[</center></body></html>]], [[<a href="]]..href..[[" target="mainpane" style="color: green">{ Get buffs }</a>%0]])
end)


-- 	add_automator("/inv_use.php", function ()
-- 		if character["automate simple tasks"] ~= "yes" then return end
-- 		if text:match([[<input class=button type=submit value="Begin the Ritual">]]) then
-- 			text = text:gsub([[(<p>You feel your clubbing muscles begin to twitch with anticipation...<p><center><form action=inv_use.php method=post)(>)]], [[%1 name="kolproxy_summonsealform"%2]])
-- 			text = text .. [[<script>document.kolproxy_summonsealform.submit();</script>]]
-- 			-- TODO: grey out button so they don't click it as well?
-- 	-- 		local pwdhash = text:match([[<input type=hidden name=pwd value=(%x-)>]])
-- 	-- 		local whichitemstr = text:match([[<input type=hidden name=whichitem value=(%x-)>]])
-- 	-- 		text = post_page("/inv_use.php", { pwd = pwdhash, whichitem = whichitemstr, checked = "1" })
-- 		end
-- 	-- 	posting page /inv_use.php params: Just [("pwd","baf939169cd8b1b342b2536c339b8592"),("whichitem","3902"),("checked","1")]
-- 	-- 	print("\n\n\n\n")
-- 	-- 	print(text)
-- 	-- 	print("\n\n\n\n")
-- 	end)

-- if mode == "intercept" then
	-- prevent adventuring in places without enough meat: palindome, spooky forest
-- end

-- castle: inv_use.php -> quantum egg -> intragalactic



-- easter egg balloon:
-- 	got uri: /storage.php |  (from /storage.php), size 353672, params: Just [("pwd","5d6ee76c54dddac276e3e7a922ee665c"),("action","take"),("howmany1",""),("whichitem1","436")]
-- 	got uri: /lair2.php |  (from /lair2.php), size 3128, params: Just [("preaction","key"),("whichkey","436")]


-- The Sleeper Has Awakened -> equip worm-riding hooks, use drum machine, equip weap/offhand again, return page

automate_noncombat_href = add_automation_script("automate-noncombat", function ()
	text, url = "Trying to automate noncombat...", requestpath
	local function f() return text, url end
	for i = 1, 100 do
		local p = params["choice" .. i]
		if p then
			local whichchoice, option = p:match("([0-9]+)%-([0-9]+)")
--			print(params["choice" .. i], whichchoice, option)
			f = async_post_page("/choice.php", { pwd = params.pwd, whichchoice = whichchoice, option = option })
		else
			break
		end
	end
	text, url = f()
	return text, url
end)

-- vamping out

add_processor("/choice.php", function()
	if adventure_title == "Interview With You" and text:contains("A small bell chimes above the door of Isabella's as you enter.") then
		print("Vamping Out at Isabella's!")
		day["vamped out.isabella"] = "yes"
	end
end)

add_printer("/town.php", function()
	if have("plastic vampire fangs") then
		if day["vamped out.isabella"] == "yes" then
			text = text:gsub("</body>", [[<center style="color: gray">{ Already vamped out at Isabella's today. }</center>%0]])
		else
			text = text:gsub("</body>", [[<center style="color: green">{ Not yet vamped out at Isabella's today. }</center>%0]])
		end
	end
end)

add_choice_text("Interview With You", {
	["Visit Vlad's Boutique"] = "Get a vampire buff",
	["Visit Isabella's"] = { text = "Get big statgain", good_choice = true },
	["Visit The Masquerade"] = "Get a vampire item",
})

add_printer("/choice.php", function()
	if adventure_title ~= "Interview With You" or not text:contains("A small bell chimes above the door of Isabella's as you enter.") then return end
	local isabella_choices = {
		Muscle = { 1, 1 },
		Mysticality = { 1, 3, 1 },
		Moxie = { 1, 2, 2, 1 },
	}
	local function make_vamp_link(goal)
		local tparams = {}
		tparams.pwd = text:match([[<input type=hidden name=pwd value='([0-9a-f]+)'>]])
		local whichchoice = text:match([[<input type=hidden name=whichchoice value=([0-9]+)>]])
		for a, b in ipairs(isabella_choices[goal]) do
			tparams[string.format("choice%d", a)] = string.format("%d-%d", whichchoice, b)
		end
		return [[<a href="]]..automate_noncombat_href(tparams)..[[" style="color: green">]] .. goal .. [[</a>]]
	end
	text = text:gsub("</form>", function(x) return x .. [[<span style="color: green">{ ]] .. make_vamp_link("Muscle") .. ", " .. make_vamp_link("Mysticality") .. ", " .. make_vamp_link("Moxie") .. [[ }</span><br>]] end)
end)

-- tea party

add_choice_text("The Mad Tea Party", function()
	local hatid = equipment().hat
	if not hatid then
		return {
			["Try to get a seat"] = "Get hat-based buff: None (you get turned away)",
			["Slouch away"] = "Leave",
		}
	else
		local hatname = item_api_data(hatid).name
		local hatchars = hatname:gsub(" ", ""):len()
		local hatbuffs = {
			[4] = "+20 to Monster Level",
			[5] = nil,
			[6] = "+3 Familiar Experience Per Combat",
			[7] = "Moxie +10",
			[8] = "Muscle +10",
			[9] = "Weapon Damage +15",
			[10] = "Mysticality +10",
			[11] = "Spell Damage +30%",
			[12] = "Maximum HP +50",
			[13] = "Maximum MP +25",
			[14] = "+10 Sleaze Damage",
			[15] = "Spell Damage +15",
			[16] = "+10 Cold Damage",
			[17] = "+10 Spooky Damage",
			[18] = "+10 Stench Damage",
			[19] = "+10 Hot Damage",
			[20] = "Weapon Damage +30%",
			[21] = nil,
			[22] = "+40% Meat from Monsters",
			[23] = "Mysticality +20%",
			[24] = "+5 to Familiar Weight",
			[25] = "+3 Stats Per Fight",
			[26] = "Moxie +20%",
			[27] = "Muscle +20%",
			[28] = "+20% Item Drops from Monsters",
		}
		return {
			["Try to get a seat"] = "Get hat-based buff: " .. (hatbuffs[hatchars] or "?") .. " (" .. hatchars .. " characters)",
			["Slouch away"] = "Leave",
		}
	end
end)

-- show banished monsters

add_automator("/fight.php", function()
	local banish_msgs = {
		"You start screaming and howling uncontrollably",
		"Blood blood blood blood BLOOOOOD",
		"get the correct volume and murderous inflection",
		"RIP AND TEAR YOUR GUTS",
		"SKULLS FOR THE SKULL THRONE",
		"stream of shouted profanities",
		"YOUR SKULL IS MIIIIINE",
		"howl grisly invocations to every god you can think of",
		"make the scariest noise you can think of",
	}
	for x in table.values(banish_msgs) do
		if text:contains(x) then
			local pt = get_page("/desc_skill.php", { whichskill = 11020, self = "true" })
			local banished = pt:match([[<blockquote.-(The following monsters.-)</blockquote>]])
			local banishmsg = ([[ <p style="color: green">]] .. tostring(banished) .. [[</p>]]):gsub("(>)([^<]*)(<br)", "%1{ %2 }%3")
			text = text:gsub("(>)([^<]*" .. x .. ".-)(<[^/i])", function(a, b, c) return a .. b .. banishmsg .. c end)
		end
	end
end)


-- auto-visit council after leveling

local last_council_visit_level = nil
add_automator("all pages", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if last_council_visit_level ~= level() then
		local _, pturl = get_page("/council.php")
		if pturl:contains("council.php") then
			last_council_visit_level = level()
		end
	end
end)

local done_on_ascension_action = nil
add_automator("/main.php", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if not done_on_ascension_action then
		async_post_page("/campground.php", { action = "telescopelow" })
		if not have("Clan VIP Lounge key") then
			freepull_item("Clan VIP Lounge key")
			async_get_page("/clan_viplounge.php", { action = "klaw" })
			async_get_page("/clan_viplounge.php", { action = "klaw" })
			async_get_page("/clan_viplounge.php", { action = "klaw" })
			async_get_page("/clan_viplounge.php", { action = "lookingglass" })
		end
		if ascensionpathid() == 8 and not have_item("Boris's Helm") and not have_item("Boris's Helm (askew)") then
			freepull_item("Boris's Helm")
			freepull_item("Boris's Helm (askew)")
		end
		if level() == 1 then
			async_get_page("/tutorial.php", { action = "toot" })
			use_item("letter from King Ralph XI")
			if ascensionpathid() ~= 4 then
				use_item("Newbiesport&trade; tent")
			end
		end
		done_on_ascension_action = true
	end
end)

add_automator("/hermit.php", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if text:contains("disappointed look on his face") or text:contains("out of Permits") then
		-- Should it be gotten for item-buying pageloads or not?
		local function get_trinket()
			if not have("worthless trinket") and not have("worthless gewgaw") and not have("worthless knick-knack") then
				print "  getting worthless item"
				if not have("chewing gum on a string") then
					buy_item("chewing gum on a string", "m")
				end
				local pt, pturl = use_item("chewing gum on a string")()
				if pt:contains("You acquire") then
					get_trinket()
				end
			end
		end
		get_trinket()
		if not have("hermit permit") then
			buy_item("hermit permit", "m")
		end
		text, url = get_page("/hermit.php")
	end
end)

add_automator("all pages", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if have("Knob Goblin encryption key") and have("Cobb's Knob map") and ascensionpathid() ~= 4 then
		use_item("Cobb's Knob map")
	end
end)

add_automator("all pages", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if level() >= 2 and not have("continuum transfunctioner") then
		async_post_page("/forestvillage.php", { action = "screwquest" })
		async_get_page("/mystic.php")
		async_post_page("/mystic.php", { action = "crackyes1" })
		async_post_page("/mystic.php", { action = "crackyes2" })
		async_post_page("/mystic.php", { action = "crackyes3" })
	end
end)

add_automator("all pages", function ()
	if character["enable ascension assistance"] ~= "yes" then return end
	if level() >= 9 and have("64735 scroll") then
		use_item("64735 scroll")
	end
end)

local open_chat_on_logon = character_setting("open chat on logon", false)

add_printer("/game.php", function()
	if open_chat_on_logon() then
		text = text:gsub("chatlaunch.php", "mchat.php")
	end
end)
